# TCL/TK UI for Render to Texture plugin
# updated for AC3D 8 (updated UI, added help popups from the original doc file)


set tfprttWidth 128
set tfprttHeight 128
set tfprttSupersample 0
set tfprttRendermode 0
set tfprttNormalMapMode 0
set tfprttPerObjectTextures 1
set tfprttCombineResult 0
set tfprttApplyTextures 1

proc tfprendertotexture_create_widgets { parent } {
   global tfprttWidth tfprttHeight tfprttSupersample tfprttRendermode tfprttNormalMapMode tfprttPerObjectTextures tfprttCombineResult tfprttApplyTextures

      ttk::frame $parent.f1
      pack $parent.f1 -side top -fill x

      ttk::label $parent.f1.titleX -text "Texture Width:" -width 15 -anchor e
      pack $parent.f1.titleX -side left -fill x -expand 1
	  add_balloon $parent.f1.titleX "Width of the output texure.  Best to use a power of 2 e.g. 128, 256, 512, 1024"

      ttk::entry $parent.f1.enterX -textvariable tfprttWidth -width 40
      pack $parent.f1.enterX -side left -fill x -expand 1


      ttk::frame $parent.f2
      pack $parent.f2 -side top -fill x

      ttk::label $parent.f2.titleY -text "Texture Height:" -width 15 -anchor e
      pack $parent.f2.titleY -side left -fill x -expand 1
	  add_balloon $parent.f2.titleY "Height of the output texure.  Best to use a power of 2 e.g. 128, 256, 512, 1024"

      ttk::entry $parent.f2.enterY -textvariable tfprttHeight -width 40
      pack $parent.f2.enterY -side left -fill x -expand 1


      ttk::frame $parent.f3
      pack $parent.f3 -side top -fill x

      ttk::label $parent.f3.titleZ -text "Super Sampling:" -width 15 -anchor e 
      pack $parent.f3.titleZ -side left -fill x -expand 1
	  add_balloon $parent.f3.titleZ "Sets the amount of oversampling that will occur when the image\n\
is rendered. Higher values result in smoother images, however,\n\
higher values may also _substantially_ increase render times\n\
and memory consumption."

      ttk::entry $parent.f3.enterZ -textvariable tfprttSupersample -width 40
      pack $parent.f3.enterZ -side left -fill x -expand 1


      ttk::frame $parent.f4
      pack $parent.f4 -side top -fill x

      ttk::label $parent.f4.titlePer -text "Multiple Textures:" -width 8 -anchor e
      pack $parent.f4.titlePer -side left -fill x -expand 1 -anchor nw


      ttk::checkbutton $parent.f4.enterPerObjectTextures -text "Append Object Name to Texture Name" -variable tfprttPerObjectTextures -width 30
      pack $parent.f4.enterPerObjectTextures -side left -fill x -expand 1 
      add_balloon $parent.f4.enterPerObjectTextures  "For multiple textures:\n\
If you would like to generate a unique texture per mesh, click \n\
this box. This will generate one texture map per mesh in the scene, \n\
using the file name you selected as the base name and appending\n\
the current object name as the remainder of the name. NOTE: Each\n\
object should have a unique name. If two objects have the same\n\
name, the second texture will be overwritten without prompting."
      
      ttk::frame $parent.f7
      pack $parent.f7 -side top -fill x

      ttk::label $parent.f7.titlePer -text "Baking:" -width 8 -anchor e
      pack $parent.f7.titlePer -side left -fill x -expand 1 -anchor nw

      ttk::checkbutton $parent.f7.enterCombineResults -text "Multiply Current Texture with Output Result" -variable tfprttCombineResult -width 30
      pack $parent.f7.enterCombineResults -side left -fill x -expand 1 
	  add_balloon $parent.f7.enterCombineResults "Baking :Multiply Current Texture with Output Result -\n\
Selecting this option causes the currently loaded texture map \n\
to be combined with the output result before saving the image\n\
to disk. This is useful when generating lightmaps if you would \n\
like to 'burn in' the original texture as well as the lighting.\n\
The final output image will be scaled to the size of the original\n\
texture map. If you have rendered low-resolution lighting, it\n\
will be upscaling to match the original texture before combining."


      ttk::frame $parent.f7a
      pack $parent.f7a -side top -fill x

      ttk::label $parent.f7a.titlePer -text "Apply textures:" -width 8 -anchor e
      pack $parent.f7a.titlePer -side left -fill x -expand 1 -anchor nw

      ttk::checkbutton $parent.f7a.enterApplyTextures -text "Load/Set output textures" -variable tfprttApplyTextures -width 30
      pack $parent.f7a.enterApplyTextures -side left -fill x -expand 1 

	  add_balloon $parent.f7a.enterApplyTextures "after rendering to a texture, the texure is loaded and set on the object"
  

      ttk::frame $parent.f5
      pack $parent.f5 -side top -fill x

      ttk::label $parent.f5.titleMode -text "Input Normal Maps:" -width 18 -anchor e         
      pack $parent.f5.titleMode -side left -fill x -expand 1 -anchor nw

      ttk::radiobutton $parent.f5.enterInputTextureNormalsObject -text "Object Space" -variable tfprttNormalMapMode -value 1 -width 40
      pack $parent.f5.enterInputTextureNormalsObject -side top -fill x -expand 1 
	  add_balloon $parent.f5.enterInputTextureNormalsObject "The light mapper and the ambient occlusion generator both support\n\
normal mapped surfaces. Selecting Object Space causes the renderer\n\
to treat any applied texture maps as object space normal maps."


      ttk::radiobutton $parent.f5.enterInputTextureNormalsTangent -text "Tangent Space" -variable tfprttNormalMapMode -value 2 -width 40
      pack $parent.f5.enterInputTextureNormalsTangent -side top -fill x -expand 1 
	  add_balloon $parent.f5.enterInputTextureNormalsTangent "The light mapper and the ambient occlusion generator both support\n\
normal mapped surfaces. Selecting\n\
Tangent Space causes the renderer to treat any applied texture maps\n\
as tangent space normal maps."
                  
      ttk::radiobutton $parent.f5.enterInputTextureNone -text "None" -variable tfprttNormalMapMode -value 0 -width 40
      pack $parent.f5.enterInputTextureNone -side top -fill x -expand 1
	  add_balloon $parent.f5.enterInputTextureNone "The light mapper and the ambient occlusion generator both support\n\
normal mapped surfaces. Selecting None causes the renderer\n\
to ignore any applied texture maps."



      ttk::frame $parent.f6
      pack $parent.f6 -side top -fill x

      ttk::label $parent.f6.titleMode -text "" -width 18 -anchor w          
      pack $parent.f6.titleMode -side left -fill x -expand 1 -anchor nw



      ttk::frame $parent.f9
      pack $parent.f9 -side top -fill x

      ttk::label $parent.f9.titleMode -text "Render:" -width 18 -anchor e           
      pack $parent.f9.titleMode -side left -fill x -expand 1 -anchor nw
      
      ttk::radiobutton $parent.f9.enterModeLighting -text "Lights and Shadows (includes AO)" -variable tfprttRendermode -value 0 -width 40
      pack $parent.f9.enterModeLighting -side top -fill x -expand 1 
		add_balloon $parent.f9.enterModeLighting "This option generates raytraced lightmaps. You must have\n\
at least one light in the scene. \n\
\n\
Colored lights can be created by clicking on a light\n\
in AC3D and selecting Object Properties. In the \n\
Object Data Text enter the word 'color' followed\n\
by R, G, B and intensity parameters. For example\n\
'color 1.0 0.0 1.0 .5' (without the quotes) would\n\
create a dim, purple light."


      ttk::radiobutton $parent.f9.enterModeAmbientOcclusion -text "Ambient Occlusion (mask)" -variable tfprttRendermode -value 5 -width 40
      pack $parent.f9.enterModeAmbientOcclusion -side top -fill x -expand 1 
                  
	add_balloon $parent.f9.enterModeAmbientOcclusion "This option generates an ambient occlusion map that\n\
may be used by various shaders to calculate lighting.\n\
\n\
Note that while ambient occlusion maps generated by\n\
the renderer may look somewhat like shadows, they are\n\
not. The output is a measure of how occluded the current\n\
surface is in all directions radiating from the normal.\n\
Many normal mapping shaders will also utilize ambient\n\
occlusion maps."


      ttk::radiobutton $parent.f9.enterModeObjectNormals -text "Object Space Normals" -variable tfprttRendermode -value 2 -width 40
      pack $parent.f9.enterModeObjectNormals -side top -fill x -expand 1
	  add_balloon $parent.f9.enterModeObjectNormals "This mode generates object space normals from the\n\
current model and encodes them to a texture map.\n\
This texture can then be applied to a low-poly\n\
model with the same UV space."
            
      ttk::radiobutton $parent.f9.enterModeTangentNormals -text "Tangent Space Normals from Object Space Map" -variable tfprttRendermode -value 4 -width 40
      pack $parent.f9.enterModeTangentNormals -side top -fill x -expand 1
      add_balloon $parent.f9.enterModeTangentNormals "This mode converts an object space normal map to\n\
a tangent space normal map. Most video games that \n\
support normal mapping require tangent space maps.\n\
\n\
To use this mode, you must first load an object space \n\
normal map texture onto your model. Typically, you \n\
will generate an object space normal map from your \n\
high poly model and then apply it to your low poly model. \n\
Both models must share the same basic UV layout. After \n\
rendering, the object space map will be converted \n\
to a tangent space map.\n\
\n\
Side note for Melody or ATI Normal Mapper users: \n\
The method used by render to texture has certain advantages \n\
and disadvantages compared to these tools. The primary \n\
disadvantage of this method compared to Normal Mapper is \n\
that the render to texture utility requires similar UVs for\n\
both the low polygon and high polygon model... this \n\
can be difficult to create for some models. The \n\
primary advantage of this method compared to Normal Mapper \n\
is that it is _significantly_ faster to render normal \n\
maps for certain types of models. This can be beneficial \n\
when creating very large / high resolution normal maps\n\
from models with relatively straightforward topology."

      ttk::radiobutton $parent.f9.enterModeTangentCrease -text "Tangent Space Normals from Crease Angle" -variable tfprttRendermode -value 3 -width 40
      pack $parent.f9.enterModeTangentCrease -side top -fill x -expand 1
      add_balloon  $parent.f9.enterModeTangentCrease "This mode encodes pertubations to the surface normals\n\
due to crease angle into a tangent space normal map.\n\
This is an exotic case, and most applications have no \n\
purpose for such maps with the exception of games and \n\
shaders that do not support crease angle. Object Space \n\
normal map or Tangent Space from Object Space normal \n\
maps are recommended instead."

      
      ttk::radiobutton $parent.f9.enterModeDisplacement -text "3D Displacement in Local Space (Sculpt Map)" -variable tfprttRendermode -value 1 -width 40
      pack $parent.f9.enterModeDisplacement -side top -fill x -expand 1
	  add_balloon $parent.f9.enterModeDisplacement "The 3D displacement mode renders the current X, Y, and Z\n\
position of the surface in normalized local space to\n\
the R, G and B channels of the texture. The output\n\
of this mode is roughly equivalent to Second Life 'normalized sculpted prim'\n\
format with the exception that the Y and Z axes are swapped."

      ttk::radiobutton $parent.f9.enterModeBurnMaterials -text "Material Colors" -variable tfprttRendermode -value 6 -width 40
      pack $parent.f9.enterModeBurnMaterials -side top -fill x -expand 1      
	  add_balloon $parent.f9.enterModeBurnMaterials "The material colors rendering mode renders the \n\
surface diffuse color (without lighting) into \n\
the texture map."

      ttk::frame $parent.f99
      pack $parent.f99 -side bottom -fill x

      ttk::button $parent.f99.ok -text "Render" -command {
         eval ac3d tfprtt_rendertotexture $tfprttApplyTextures $tfprttWidth $tfprttHeight $tfprttSupersample $tfprttRendermode $tfprttNormalMapMode $tfprttPerObjectTextures $tfprttCombineResult 0 0 0 0 0 0 0
         eval ac3d redraw_all
      }
      pack $parent.f99.ok -side left

	  ac_label $parent.f99.help -text "Troubleshooting"
	  pack $parent.f99.help -side right
	  add_balloon $parent.f99.help "Troubleshooting:\n\
\n\
IMPORTANT: Make sure your texture space is unique. Overlapping UVs will\n\
cause a variety of lighting issues. Problem areas may show\n\
up as light or dark spots on the final image.\n\
\n\
As well, make sure there are sufficient borders between \n\
UV islands. Areas of the map that are placed too close together \n\
may cause texture bleeding and show up as highlights along\n\
the seams.\n\
\n\
If your lightmapped scene renders as black, make sure you \n\
have at least one light and that it is bright enough. You \n\
may need to boost the intensity of far away lights in \n\
the object properties. Conversely, lights should also be\n\
placed to close to objects to ensure the angle is not too \n\
steep. In particular, lights should not intersect \n\
with objects.\n\
\n\
Lighting is rendered from the direction of the surface normal\n\
as if the surface were a one-sided shape, even if the surface\n\
is set to two-sided in AC3D. So, make sure normals face outwards\n\
\n\
Hidden objects are ignored.  Locked objects are treated as present\n\
(i.e. they can cast shadows and influence the lighting on other objects)\n\
but they will not have a texture rendered."


}


proc tfprendertotexture_dialog {} {

	ac_toplevel_with_close .rendertotexture  "Render to texture"  tfprendertotexture_create_widgets

}