# AC3D
# Copyright (c) 2016, Inivis Limited. All rights reserved.



##################################
# capture stdout

if {0} {

toplevel .outputtest
label .outputtest.l -textvariable myBuffer
pack .outputtest.l -fill both -expand 1

oo::class create CapturingTransform {
    variable var
    constructor {varName} {
        # Make an alias from the instance variable to the global variable
        my eval [list upvar \#0 $varName var]
    }
    method initialize {handle mode} {
        if {$mode ne "write"} {error "can't handle reading"}
        return {finalize initialize write}
    }
    method finalize {handle} {
        # Do nothing, but mandatory that it exists
    }

    method write {handle bytes} {
        append var $bytes

		set fo [open "/tmp/ac3dout.txt" a]
		fconfigure $fo -buffering none
		puts $fo "PUTS $bytes"
		close $fo

        # Return the empty string, as we are swallowing the bytes
        return ""
    }
}


# Attach an instance of the capturing transform
set myBuffer ""
puts "GRABBING STDOUT IN TCL"
chan push stdout [CapturingTransform new myBuffer]
puts "GRABBED STDOUT IN TCL"
}
# end if 0
###################


#puts [ttk::style theme names]
#Windows - winnative clam alt default classic vista xpnative
#Mac -  aqua clam alt default classic




source tcl/ac3dtheme.tcl

ttk::style theme use ac3d

configure_ac3d_theme

source "tcl/ac3dwidget.tcl"






#ttk::label .t.ut -text "Japan  \u65E5\u672C\u25BC \u2611 \u2714 \u2304 \u25be \u25BC \u25B6 \u2228 \u2713"
#\u2713 nice tick





    # VertScrollFrame based on sframe code by Paul Walton
    # Create a ttk-compatible, scrollable frame widget.
    #   Usage:
    #       sframe create <path> ?-toplevel true?  ?-anchor nsew? -?side left|right
    #       -> <path> 
    #
    #       sframe get_container <path>
    #       -> <path of child frame where the content should go>
    
    namespace eval ::VertScrollFrame {
        namespace ensemble create
        namespace export *
    
        # Create a scrollable frame or window.
        proc create {path  args} {
            
			# Create the main frame
            ac_frame $path

			# -side specifies which side the scroll bar goes
            set side "left"
            if { [dict exists $args -side] } {
                set side [dict get $args -side]
            }

            # Create a scrollable canvas with scrollbars which will always be the same size as the main frame.
            set canvas [ac_canvas $path.canvas -width 0 -height 0 -borderwidth 0 -highlightthickness 0 -yscrollcommand [list $path.scrolly set] -xscrollcommand [list $path.scrollx set]]
			# on Mac, need to ensure -class TScrollbar is inclued, otherwise we get a Native scrollbar!
            ac_scrollbar $path.scrolly -class TScrollbar -orient vertical   -command [list $canvas yview]
            ac_scrollbar $path.scrollx -class TScrollbar -orient horizontal -command [list $canvas xview]

			if { $side == "left" } {
				set padding "0 4"
			} else {
				set padding "4 0"
			}
			pack $path.scrolly  -side $side -fill y -expand 0 -padx $padding
            
            # Create a container frame which will always be the same size as the canvas or content, whichever is greater. 
            # This allows the child content frame to be properly packed and also is a surefire way to use the proper ttk background.
            set container [ac_frame $canvas.container]
 #           pack propagate $container 0
  pack $container
            
            # Create the content frame. Its size will be determined by its contents. This is useful for determining if the 
            # scrollbars need to be shown.
            set content [ac_frame $container.content]
            
            # Pack the content frame and place the container as a canvas item.
            set anchor "n"
            if { [dict exists $args -anchor] } {
                set anchor [dict get $args -anchor]
            }
            pack $content -anchor $anchor
            $canvas create window 0 0 -window $container -anchor nw
            
            # Grid the scrollable canvas sans scrollbars within the main frame.
pack $canvas -fill both -expand 1
#            grid $canvas   -row 0 -column 0 -sticky nsew
#            grid rowconfigure    $path 0 -weight 1
#            grid columnconfigure $path 0 -weight 1
            
            # Make adjustments when the sframe is resized or the contents change size.
            bind $path.canvas <Expose> [list [namespace current]::resize $path]
            bind $container <Configure> [list [namespace current]::resize $path]
			         
            # Mousewheel bindings for scrolling.
#            bind [winfo toplevel $path] <MouseWheel>       [list +[namespace current] scroll $path yview %W %D]
 #           bind [winfo toplevel $path] <Shift-MouseWheel> [list +[namespace current] scroll $path xview %W %D]
#             bind $path <MouseWheel>       {puts "vertframescroll got mouse wheel event }
#			[list +[namespace current] scroll $path yview %W %D]
#            bind $path <Shift-MouseWheel> [list +[namespace current] scroll $path xview %W %D]
 
            
            return $path
        }
    
    
        # return the path of the child frame suitable for content.
        proc get_container {path} {
			# badly named function, we are actual getting the content widget
            return $path.canvas.container.content
        }
    
    
        # Make adjustments when the the sframe is resized or the contents change size.
        proc resize {path} {
            set canvas    $path.canvas
            set container $canvas.container
            set content   $container.content

			set width [winfo reqwidth [ winfo parent $content]]
			set height [winfo reqheight [ winfo parent $content]]
#			puts "container req width $width height $height"

			$canvas configure  -width $width 

#			set cheight [winfo height $canvas]
#			$container configure -height $cheight

            if { [winfo reqwidth $content] > $width } {
                set width [winfo reqwidth $content]
            }
            if { [winfo reqheight $content] > $height } {
                set height [winfo reqheight $content]
            }
 #           $container configure  -width $width  -height $height
    
            # Configure the canvas's scroll region to match the height and width of the container.
            $canvas configure -scrollregion [list 0 0 $width $height]

			# enable the scrollbar if needed
			if {  [winfo reqheight $content] > [winfo height $canvas] } {
				$path.scrolly state !disabled
			} else {
				$path.scrolly state disabled
			}


return

			# get size of parent
			set width [winfo width [ winfo parent $path]]
			set height [winfo height [ winfo parent $path]]
	
#		puts "parent width $width height $height"
				
			# set the size of the container to be the same
			$container configure  -width $width  -height $height
			

						
            # Set the size of the container. At a minimum use the same width & height as the canvas.
#            set width  [winfo width $canvas]
 #           set height [winfo height $canvas]
            
			set  width [expr $width - [winfo width $path.scrolly]]

			$canvas configure  -width $width 
#			$canvas configure  -height $height

            # If the requested width or height of the content frame is greater then use that width or height.
            if { [winfo reqwidth $content] > $width } {
                set width [winfo reqwidth $content]
            }
            if { [winfo reqheight $content] > $height } {
                set height [winfo reqheight $content]
            }
            $container configure  -width $width  -height $height
    
            # Configure the canvas's scroll region to match the height and width of the container.
            $canvas configure -scrollregion [list 0 0 $width $height]
 
 return;
    
            # Show or hide the scrollbars as necessary.
            # Horizontal scrolling.
            if { [winfo reqwidth $content] > [winfo width $canvas] } {
                grid $path.scrollx  -row 1 -column 0 -sticky ew
            } else {
                grid forget $path.scrollx
            }
            # Vertical scrolling.
            if { [winfo reqheight $content] > [winfo height $canvas] } {
                grid $path.scrolly  -row 0 -column 1 -sticky ns
            } else {
                grid forget $path.scrolly
            }
            return
        }
    
    
        # Handle mousewheel scrolling.    
        proc scroll {path view W D} {
            if { [winfo exists $path.canvas]  &&  [string match $path.canvas* $W] } {
                $path.canvas $view scroll [expr {-$D}] units
            }
            return
        }
    }






##################


# for drag/drop:

#if { [catch { package require tkdnd } ] } {
#	puts "FAILED TO OPEN TKDND - DLL MAY BE MISSING OR WRONG PLATFORM TYPE"
#}

package require tkdnd 


#

# main AC3D TCL file defines control panel UI

#set screen [ winfo screen .]
#set screenwidth [winfo screenwidth .]
#set screenheight [winfo screenheight .]
#puts "Screen $screen is $screenwidth x $screenheight"


#puts [winfo name .]
  wm protocol . WM_DELETE_WINDOW { menu_quit }

#bind Entry <Return> "catch {set tv \[%W cget -textvariable \]; set \$tv \[expr \[%W get\]\]}"

# make Entry widgets calculators
#bind Entry <Return> {catch {set tv [%W cget -textvariable ]; set $tv [expr [%W get]]} }



if { $ac_platform == "Linux" } {
 bind all <Button-4> \
   {event generate [focus -displayof %W] <MouseWheel> -delta  120}

 bind all <Button-5> \
   {event generate [focus -displayof %W] <MouseWheel> -delta -120}
}


#puts "platform: $ac_platform OS: $tcl_platform(os)"

catch {
	if {$prefs_default_dir != ""} { cd $prefs_default_dir }
}





#tk appname AC3D
#puts "TCL/TK appname: [tk appname]"


set tk_strictMotif $prefs_tk_strictmotif

#setting no font makes checkbuttons on the MAC not mess up.

#if { ($ac_platform == "Linux")  || ($ac_platform == "Sun") } {
#  if { $prefs_font_main != "" } {
#    option add *font     $prefs_font_main
#    }
#  if { $prefs_font_menu != ""} {    
#    option add *Menubutton*font  $prefs_font_menu
#    }
#}

#if { $ac_platform == "Mac" } {
#	option add *font $prefs_font_main

#  if { $prefs_font_menu != ""} {    
#    option add *Menu*font  $prefs_font_menu
#    } else {
#		option add *Menu*font  TkMenuFont
#	}
#}

#option add *font -*-*-*-*-*-*-10-*-*-*-*-*-*-*

#option add *font "{Bitstream Vera Sans} 10"

# try and please the Tucows windows reviewer:
if { $tcl_platform(platform) == "windows" } {
	wm minsize . 745 520
}

# there is an odd default max size on the Mac (smaller than the screen) - set it bigger
if { $ac_platform  == "Mac" } {
	wm maxsize . 8192 9192
}


set highlight 0

# if strict motif is on then you must add one to ypad for same appearance
if { $tk_strictMotif == 1 } {
    set ypad 1
} else {
    set ypad 0
}



# define our own exit proc so we can trap Mac exit 
# shoudl be fine for other platforms too
# menu_quit in ac3dops now calls __exit to really quit

rename exit __exit

proc exit { } {
	menu_quit
}







proc bypass_system_dialogs {} {

    # Mac System 10.4.8 causes an intermittant (1 in 50?) hang problem related to dialogs.  The hang would occur 
	# occasionally when a system dialog was closed by pressing an OK button (e.g. Object->Optimize-Vertices).
	# If a hang occurred, with menus would activate but would all menu items would be disabled and it was not possible to return
	# control back to the program

	# switch off system dialogs so Tcl/Tk uses homegrown versions - Mac OS X AC3D only
	# prevents the hanging bug where closing a dialog sometimes didn't ungrab the AC3D UI


    proc ::tk_messageBox {args} {
        return [eval tk::MessageBox $args]
    }
    
    proc ::tk_chooseColor {args} {
		return [tk::dialog::color:: {*}$args]
	}

	proc ::tk_getOpenFile {args} {
			return [::tk::dialog::file:: open {*}$args]
    }

	proc ::tk_getSaveFile {args} {
			return [::tk::dialog::file:: save {*}$args]
   	}

    proc ::tk_chooseDirectory {args} {
		return [::tk::dialog::file::chooseDir:: {*}$args]
    }
    
	puts "system dialogs bypassed"
}


proc bypass_system_file_dialogs {} {
# now unused
	# switch off system file dialogs so Tcl/Tk uses homegrown versions - Mac OS X AC3D only

	puts "system file dialogs bypassed"
}










proc horiz_pack {parent args } {
    foreach i $args {
        pack $i -in $parent -side left -fill both -expand 1 -pady 0 -padx 0 -ipady 0 -ipadx 0
    }
}

proc vert_pack {parent args } {
    foreach i $args {
        pack $i -in $parent -side top -fill both -expand 1 -pady 0 -padx 0
#        pack $i -in $parent -side top  -pady 0 -padx 0
    }
}


set draw_mode move



proc trace_proc { name1 name2 op } {
global currentrb cp
global drawmode_preserve
global oldbg



    upvar $name1 newval

    set n $name1.id($newval)
    upvar #0 $n mhit


puts "traceproc mhit $mhit  currentrb($name) $currentrb($name)"

	# if it's the same mode we are in at the moment - do nothing
	if { $mhit == $currentrb($name1) } { return }
		
	# raise the current radio button
	# note that the "off" releif is now flat i.e. no border was "raised"
#    $currentrb($name1) configure -relief flat -background $oldbg

# dont need to unselect one now they are radio buttins? - $currentrb($name1) state !selected

    set currentrb($name1) $mhit
	# sink the new one
#    $currentrb($name1) configure -relief sunken
$currentrb($name1) state selected
#	puts traceproc
}


proc check_keep_down { name variable value } {
global drawmode_preserve
global $variable

    if { [set $variable] == $value} {
		set drawmode_preserve true	
		$name configure -background green
	} else {
		set drawmode_preserve false
	}

}






proc ac_axis_selector { name variable } {

	ac_frame $name
	ttk::frame $name.a
	# -style radio.TFrame
	# -borderwidth 2
	ac_label $name.a.lab -text "axis:"

	ac_create_radiobutton_strip $name.a.axissel $variable { X Y Z C } { x y z c}  "set_buttons $variable \$$variable" 
	grid $name.a.axissel

    proc set_custom_axis { var } {
		
		upvar #0 $var.axis axis
		upvar #0 $var.cent cent
		upvar #0 $var.current_axis current_axis
		upvar #0 $var.button button
	
		set asel [ac3d get_axis_from_selection]
		if { $asel == "" } {
			set axis "0 1 0"
		} else {
			set axis $asel
		}
		set cent [ac3d get_selection_centre]
	}
		
    
	set b [ac_button $name.a.setc -text "Set custom axis" -command "set_custom_axis $variable" ]
	add_balloon $b "define the custom rotate axis from two selected vertices"
	
	upvar #0 $variable.axis axis
	upvar #0 $variable.cent cent
	upvar #0 $variable.current_axis current_axis
	upvar #0 $variable.button button
		
	set axis "1 0 0"
	set cent "0 0 0"	
	set current_axis "x"
	set button $b

		
    proc set_buttons { var a } {
	
		upvar #0 $var.axis axis
		upvar #0 $var.cent cent
		upvar #0 $var.current_axis current_axis
		upvar #0 $var.button button
	
		set current_axis $a
				
		if {$a == "x"} {
			grid forget $button
		} elseif {$a == "y" } {
			grid forget $button
		} elseif {$a == "z" } {
			grid forget $button
		} elseif {$a == "c" } {
			grid $button -column 0 -row 1 -columnspan 4 -sticky we
		}
		

#		puts "axis $axis cent $cent"
    }
    

	pack $name.a -side left -fill x -expand 1

	
	# default is X set
	uplevel #0 "set $variable x"

	return $name
}



proc axis_selector_do_rotate { var degs} {
	upvar #0 $var.cent cent
	upvar #0 $var.current_axis current_axis
	upvar #0 $var.axis custaxis
	
	set a $current_axis
	
	# for x, y, z rotation, use the center of the selection
	set centrot [ac3d get_selection_centre]
	
		if {$a == "x"} {
			set axis "1 0 0"
		} elseif {$a == "y" } {
			set axis "0 1 0"
		} elseif {$a == "z" } {
			set axis "0 0 1"
		} elseif {$a == "c" } {
			# for custome axis rot - use the last customs axis and center
			set axis $custaxis
			set centrot $cent
		}
	
#	puts "rotating axis $axis    centrot $centrot"
	
	ac3d rotate_full_axis_angle [lindex $axis 0] [lindex $axis 1] [lindex $axis 2] \
		[lindex $centrot 0] [lindex $centrot 1] [lindex $centrot 2]  [expr $degs]
}








proc mode_button {name text command variable value { helptext "" } { keepdownable false} { bitmapimage "" } } {
global highlight
global ypad
global tcl_version
global $variable
global currentrb
global bitmap
global oldbg
global icon_buttons

ttk::radiobutton $name -style mode.Toolbutton  -text $text -variable $variable -value $value -command $command -takefocus 0

if { ($bitmapimage != "") } {
	$name configure -image $bitmapimage
}
	if { $helptext != "" } {
		add_balloon $name $helptext
	}

return $name

puts "mode_button  var $variable  value $value"

#    label $name -text $text -relief flat -borderwidth 1

#	set oldbg [$name cget -background]

#$name configure -bg eeeeee

if { $bitmapimage != "" } {
	$name configure -image $bitmapimage
}

    if { [set $variable] == $value} {
        puts "set current"
		$name state selected
	}

################
if (0) {
#    bind $name <ButtonPress-1> "%W configure -relief sunken -background orange"

	if { $keepdownable } {
		set ckd "check_keep_down $name $variable $value"
	} else {
		set ckd "set drawmode_preserve false; set $variable $value"
	}
#    bind $name <ButtonRelease-1> "$ckd ; $command; if { \$drawmode_preserve } {$name configure -background green}"
    catch {$name config -image $bitmap($value)}

    set winname "$variable.id($value)"
    uplevel #0 " set $winname $name "
    upvar #0 $winname poo

    if { [set $variable] == $value} {
        $name state selected
		set currentrb($variable) $name
#		trace variable $variable w trace_proc
#		puts "tracing $variable"
    }
}
#################
	if { $helptext != "" } {
		add_balloon $name $helptext
	}
	return $name

}








proc cbutton {name text command {helptext ""} } {
global highlight
global ypad
global tcl_version

# standard buttons are too big
ttk::button $name -text $text -command $command 
# (adding -padding 0 makes it minimum height)
 
	if { $helptext != ""} {
		add_balloon $name $helptext
	}
#button $name -text $text -command $command -borderwidth 1 -highlightthickness 0 -padx 0 -pady 0
return $name

    # add a bit more vertical spacing on the Mac - looks much nicer
#    if { [ac3d get_platform] == "Mac" } {
#	set pady 2
#    } else {
	set pady 1
#    }

#	label $name -text $text -relief raised -pady $pady -padx 2 -bd 1
# Mac cocoa changes

	ttk::label $name -text $text -relief raised -borderwidth 1 -padding "4 1 4 1"
#	ttk::frame $name -width 20 -height 30 -border 10

	# Windows TTK - unable to change borderwidth unless in 'default' ttk
	# padding order - "left top right bottom"

	if { $helptext != ""} {
		add_balloon $name $helptext
	}

	bind $name <ButtonPress-1> { %W configure -relief sunken }
	bind $name <ButtonRelease-1> " if { \[%W cget -relief\] == \"sunken\" } { %W configure -relief raised ; $command } "

	return $name
}



	image create photo tick -file "tcl/images/tick.png"
	image create photo tickempty -file "tcl/images/tickempty.png"

proc ac_checkbutton_OLD { name text command variable { helptext "" } } {

ttk::checkbutton $name  -text $text -variable $variable -command $command
return $name

#    checkbutton $name -text $text -highlightthickness 0 -variable $variable -command $command
#	if { $helptext != "" } {
#		add_balloon $name $helptext
#	}
#	return $name

		proc cbhit { widget var } {

		# called when a custom check button is hit - toggles value and changes tick
		upvar #0 $var val
		#puts "val of $var is $val"

			if { $val } {
				$widget.cbtick configure -image tickempty
				set val 0
			} else {
				$widget.cbtick configure -image tick
				set val 1
			}
		}


	# handmade widget - primarily so the native mac stuff doesn't appear
	ac_frame $name
	ac_label $name.cbtick -relief sunken 
	ac_label $name.cblabel -text "$text" 

	bind $name.cbtick <ButtonPress-1> "cbhit $name $variable; $command"
	bind $name.cblabel <ButtonPress-1> "cbhit $name $variable; $command"

	$name.cbtick configure -image tick

	pack $name.cbtick -padx 1 -side left
	pack $name.cblabel -side left

	# must initialise the var if it's not already set
	upvar #0 $variable val
	if { ![info exists val] } {	set val 0 }

	if { $val } {
		$name.cbtick configure -image tick
	} else {
		$name.cbtick configure -image tickempty
	}

	if { $helptext != "" } {
		add_balloon $name.cbtick $helptext
		add_balloon $name.cblabel $helptext
	}

	return $name
}






proc maximize_cp {} {

set g [wm maxsize .]
puts $g

}

































proc accel { a } {
global ac_platform

	if { $ac_platform != "Mac" } {
		return $a
	}

	set pos [string first Ctrl $a]
	if { $pos == -1 } {
		return
	} else {
		return [string replace $a $pos [expr $pos + 3] "Command"]
	}
}





proc start_web_browser_file { file } {
global AC3D_HOME

	set full [ file join $AC3D_HOME $file ]
	set fullfile "file://$full"

	ac3d start_web_browser "$fullfile"
}





proc make_coorwindow { w { menu ""} } {

#    if {[winfo exists .coorwindow]} { destroy .coorwindow }

    ac_frame $w.message_frame 
    # -bd 2 -relief groove
    ac_label $w.message_frame.select_mode_info -text "objects/vert selected" -textvariable select_info
	#  -padx 0 -pady 0
    ac_label $w.message_frame.display_line_coors -text "" -textvariable coors
	# -padx 0 -pady 0
    ac_label $w.message_frame.display_line_size -text "" -textvariable size
	# -padx 0 -pady 0

#    pack $w.message_frame.select_mode_info $w.message_frame.display_line_coors $w.message_frame.display_line_size  -in $w.message_frame -side left -fill x
	grid  $w.message_frame.select_mode_info -row 0 -column 0  -sticky we
	grid  $w.message_frame.display_line_coors -row 0 -column 1 -sticky we
	grid  $w.message_frame.display_line_size -row 0 -column 2 -sticky we
	grid columnconfigure $w.message_frame 0 -weight 1 -uniform 1
	grid columnconfigure $w.message_frame 1 -weight 1 -uniform 1
	grid columnconfigure $w.message_frame 2 -weight 1 -uniform 1

	label $w.dummy -text " "

	#    pack $w.message_frame -in $w -side left -fill x -expand 1 -padx 3
	grid $w.message_frame -row 0 -column 0 -sticky we
	#grid $w.dummy -row 0 -column 1 -sticky w

	grid columnconfigure $w 0 -weight 1 -uniform 1
	#grid columnconfigure $w 1 -weight 1 -uniform 1

	if { $menu != "" } {
	    bind $w.message_frame.select_mode_info <3> " tk_popup $menu %X %Y "
		bind $w.message_frame.display_line_coors <3> " tk_popup $menu %X %Y "
		bind $w.message_frame.display_line_size <3> " tk_popup $menu %X %Y "
	}
}







proc add_tool_mode_button { win  text command variable toolname helptext { keepdownable false} { bitmapname "" } } {

    set b [mode_button $win  $text $command $variable "$toolname" $helptext $keepdownable ]

#return $b
######## remove the return for icons

	if { $bitmapname != ""} {
		image create photo $toolname -file tcl/images/$bitmapname  
		$b configure -width 36 -image $toolname
#	} else {
#		image create photo default -file tcl/images/sphere.png
#		$b configure -width 48 -height 48 -image default
#	}


	return $b
#	pack $b -side left
		
}










source "tcl/ac3dgadgets.tcl"





# main control panel

# this pref could be added - tested and working, but ugly
#ac3d add_pref mode_panels_foldable 1
set prefs_mode_panels_foldable 1


proc mode_section:create { win title { opt ""}} {
global prefs_mode_panels_foldable

	if { $prefs_mode_panels_foldable } {
		return [ FoldFrame:create $win $title]
	} else {
		return [ ttk::labelframe $win -text $title ]
	}
}

proc mode_section:get_container { win } {
global prefs_mode_panels_foldable

	if { $prefs_mode_panels_foldable } {
		return [ FoldFrame:get_container $win ]
	} else {
		return $win
	}
}


proc set_mode_param_title { modename } {
global UI
global prefs_mode_panels_foldable

	if { $modename == "move" } { set modename "Move/Size" }
	if { $modename == "circle" } { set modename "Ellipse" }

	set modename [string totitle $modename ]

	if { $prefs_mode_panels_foldable } {
		FoldFrame:set_title $UI(mode_param_frame) $modename
	} else {
		$UI(mode_param_frame) configure -text $modename
	}
}



proc make_control_panel { } {
global drag_mode draw_mode cp object_detail_frame undo_string
global UI object_detail_canvas ac_platform cp cp2 
global select_mode

	set w $cp
	make_coorwindow $UI(infobar)

	set select_mode tree

	# vert dist between sections
	set section_ypad 0


	set select_mode_frame [ mode_section:create $cp.select_mode_frame "Select" 1 ]
	set f [ mode_section:get_container $select_mode_frame]

#	set select_mode_frame [ac_frame $cp.select_mode_frame -borderwidth 2 -relief raised]
#	set f $select_mode_frame

    set UI(select_mode_tree) [add_tool_mode_button $f.select_mode_tree  " Group "  "ac3d set_select_mode  0; ac3d redraw_all" select_mode tree "Group - Select/manipulate\ngroups and objects (key g)" false group.png]
    set UI(select_mode_object) [add_tool_mode_button $f.select_mode_object  " Object "  "ac3d set_select_mode  1 ; ac3d redraw_all" select_mode object "Object - Select/manipulate\nwhole objects (key o)" false object.png]
    set UI(select_mode_surface) [add_tool_mode_button $f.select_mode_surface  " Surface "  "ac3d set_select_mode  2 ; ac3d redraw_all"  select_mode surface "Surface - Select/manipulate individual\nsurfaces (key s)" false surface.png]
    set UI(select_mode_vertex) [add_tool_mode_button $f.select_mode_vertex  " Vertex "  "ac3d set_select_mode  3 ; ac3d redraw_all"  select_mode vertex "Vertex - Select/manipulate individual\nvertices (key v)" false vertex.png]

	grid $UI(select_mode_tree) -row 0 -column 0 -sticky we
	grid $UI(select_mode_object) -row 0 -column 1 -sticky we
	grid $UI(select_mode_surface) -row 0 -column 2 -sticky we
	grid $UI(select_mode_vertex) -row 0 -column 3 -sticky we
	grid columnconfigure $f "all" -weight 1

	pack $select_mode_frame -side top -fill x -pady $section_ypad -anchor n


    set drag_mode move


    set modeframe [mode_section:create $cp.draw_mode_frame "Mode" 1 ] 
	set f [mode_section:get_container $modeframe ]

    add_tool_mode_button $f.drag_mode_move  "MoveSize"  "ac3d set_draw_mode  move" draw_mode move "Move/Size - Left mouse button will select/drag selection, handles resize (key = m)" false movesize.png
    add_tool_mode_button $f.drag_mode_rotate  "Rotate"  "ac3d set_draw_mode  rotate" draw_mode rotate "Rotate - Left mouse button will select/rotate\nselection about mouse pos (key = r)" false rotate.png
    add_tool_mode_button $f.drag_mode_extrude  "Extrude"  "ac3d set_draw_mode  extrude" draw_mode extrude "Extrude - Left mouse button will select/extrude selected surfaces to release point (key = e)" false extrude.png
    set UI(extrude_button) $f.drag_mode_extrude

    add_tool_mode_button $f.draw_mode_polygon  "Poly"  "ac3d set_draw_mode  polygon"  draw_mode polygon "Polygon - Draw a polygon\n (Click left mouse button for each vertex,\n right or middle button to finish)" true polygon.png
    add_tool_mode_button $f.draw_mode_polyline  "Polyline"  "ac3d set_draw_mode  polyline"  draw_mode polyline "Polyline - Draw a polygon outline\n (Click left mouse button for each vertex,\n right or middle button to finish)" true polyline.png
    add_tool_mode_button $f.draw_mode_line "Line"   "ac3d set_draw_mode  line"  draw_mode line "Line - Draw a line\n (Click left mouse button for each vertex,\n right or middle button to finish)" true line.png
    add_tool_mode_button $f.draw_mode_rect  " Rect "  "ac3d set_draw_mode  rect"  draw_mode rect "Rect - Draw a rectangle" true rect.png
    add_tool_mode_button $f.draw_mode_circle  "Ellipse"  "ac3d set_draw_mode  circle"  draw_mode circle "Ellipse - Draw an circle/ellipse" true ellipse.png
    add_tool_mode_button $f.draw_mode_disk  "Disk"  "ac3d set_draw_mode  disk"  draw_mode disk "Disk - Draw a disk" true disk.png
    add_tool_mode_button $f.draw_mode_cube  "Box"  "ac3d set_draw_mode  box"  draw_mode box  "Box - Draw a cuboid" true box.png
    add_tool_mode_button $f.draw_mode_sphere  "Sphere"  "ac3d set_draw_mode  sphere" draw_mode sphere "Sphere - Draw a sphere" true sphere.png
    add_tool_mode_button $f.draw_mode_cone  "Cylinder"  "ac3d set_draw_mode  cylinder"  draw_mode cylinder "Cylinder - Draw a cylinder" true cylinder.png
    add_tool_mode_button $f.draw_mode_mesh  "Mesh"  "ac3d set_draw_mode  mesh"  draw_mode mesh "Mesh - Draw a mesh" true mesh.png
    add_tool_mode_button $f.draw_mode_block  "Block"  "ac3d set_draw_mode  block"  draw_mode block "Block - Draw a block object" true "block.png"
    add_tool_mode_button $f.draw_mode_light  "Light"  "ac3d set_draw_mode  light"  draw_mode light "Light - Click to position a new light" true light.png

	ac_label $f.s1 -text " " 
	ac_label $f.s2 -text " " 



    grid $f.drag_mode_move  -row 0 -column 0 -sticky we
    grid $f.drag_mode_rotate  -row 0 -column 1 -sticky we
    grid $f.drag_mode_extrude  -row 0 -column 2 -sticky we
    grid $f.draw_mode_polygon  -row 2 -column 0 -sticky we
    grid $f.draw_mode_polyline -row 2 -column 1 -sticky we 
    grid $f.draw_mode_line  -row 2 -column 2 -sticky we
    grid $f.draw_mode_circle -row 4 -column 0 -sticky we
    grid $f.draw_mode_disk  -row 4 -column 1 -sticky we
    grid $f.draw_mode_rect -row 4 -column 2 -sticky we
    grid $f.draw_mode_mesh -row 5 -column 0 -sticky we
    grid $f.draw_mode_block -row 5 -column 1 -sticky we
    grid $f.draw_mode_cube -row 5 -column 2 -sticky we
    grid $f.draw_mode_cone -row 6 -column 0 -sticky we
    grid $f.draw_mode_sphere -row 6 -column 1 -sticky we
    grid $f.draw_mode_light -row 6 -column 2 -sticky we

	grid columnconfigure $f all -weight 1


	pack $modeframe -side top -fill x -pady $section_ypad -anchor n 
	


	trace variable draw_mode w draw_mode_changed


	# OBJECT DETAIL FRAME
	set object_detail_outer [ mode_section:create $w.fr "Mode Params" 1]
	set f [mode_section:get_container $object_detail_outer]

	set UI(mode_param_frame) $object_detail_outer
	set UI(object_detail_frame) $f

	# PACK THE MAIN STUFF
    pack $object_detail_outer -side top -fill x -expand 1 -anchor n -pady $section_ypad



    set undo_string "Undo"
	
}
# end of make_control_panel








proc populate_bottombar { } {

global UI prefs_ui
global prefs_show_objectcentres prefs_show_drawgrid prefs_gridsnap prefs_lock_move_axis prefs_select_transparent prefs_realtime_manipulation

	#ac_checkbutton $UI(bottombar).setting_show_centres "+" "ac3d redraw_orth" prefs_show_objectcentres  "Show/hide object centres"
	#ac_checkbutton $UI(bottombar).setting_show_grid "Grid" "" prefs_show_drawgrid "Switch drawn grid"
	##ac_checkbutton $UI(bottombar).setting_gridlock "Gridsnap  " ""  prefs_gridsnap "snap to grid when drawing and dragging"
	#ac_checkbutton $UI(bottombar).setting_lock_move_axis "Lock move axis" "" prefs_lock_move_axis "Automatically lock manipulation movement to one axis only?\n(the drag axis is normally locked by holding down the Control key when first dragging)"
	##ac_checkbutton $UI(bottombar).setting_select_transparent "Select through" "" prefs_select_transparent "Select all the way through geometry?"

	#ac_checkbutton $UI(bottombar).setting_realtimefeedback "Feedback  " "" prefs_realtime_manipulation "show realtime manipulation or drag a box?"

#    pack \
 #      $UI(bottombar).setting_gridlock $UI(bottombar).setting_select_transparent \
#	   -side left -padx 3 -pady 2


	set UI(progressbar) [  ac_canvas $UI(bottombar).progressbar -width 3c -height 0.3c -relief sunken -borderwidth 0 ]
    $UI(bottombar).progressbar create rectangle -20 -20 -20 -20 -fill $prefs_ui(selectbackground) -tags rect 
    add_balloon $UI(bottombar).progressbar "This is a progress bar"
  
#	set UI(progressbar) [ ttk::progressbar $UI(bottombar).progressbar -orient horizontal  ]
    pack $UI(bottombar).progressbar -side right

    set UI(messagelabel) [ac_label $UI(bottombar).message -textvariable message]
    add_balloon $UI(bottombar).message "This is a message area"
    pack $UI(bottombar).message -fill x  -expand 0

}


	############################################################

	# MAIN UI SETUP

	
	wm title . "Inivis AC3D"

	do_toplevel_bindings .

	#wm geometry . ${prefs_windowwidth}x${prefs_windowheight}+$prefs_windowx+$prefs_windowy



	global prefs_mainwin_maxed
	if { $prefs_mainwin_maxed } { 
		if { $ac_platform != "Linux" } {		

			if { $ac_platform == "Mac" } {
				# if zooming window on Mac, we need to set a min size and a requested max to make it work and then shrink to something useful later
				set screenw [winfo screenwidth .]
				set screenh [winfo screenheight .]
				wm minsize . 1024 768
				set geom ${screenw}x${screenh}
				wm geometry . $geom
			}

			wm state . zoomed
		} else {
			wm attributes . -zoomed true
		}
	} else {
		wm geometry . ${prefs_windowwidth}x${prefs_windowheight}+$prefs_windowx+$prefs_windowy
	}


	keep_on_screen .


#	puts "before mbar color array in theme:" 
#	puts [array get colors]


        menu .mbar -tearoff 0 -type normal
	
	set UI(mainframe) [ ac_frame .toplevelframe -borderwidth 4 ]
	pack $UI(mainframe) -fill both -expand 1

	set leftpane [ttk::panedwindow $UI(mainframe).pane ]
	set UI(leftpane) $leftpane
	pack $leftpane -side left -fill y -padx {1 3} -pady 1

# scrolling images inside a scrolly frame caused crashes in TK on Mac OSX
# this was not fixed with Tk 8.6.6, pain to debug tk on mac, so just use a frame widget now

#	set topscroll [VertScrollFrame create $leftpane.scrollcp -side right]
#	pack $topscroll -side left -padx 4 -pady 1
#	set cpcont [VertScrollFrame get_container $topscroll]
#	set toppane [$leftpane add $topscroll -weight 1]
#	set topscroll [ac_canvas $leftpane.scrollcp ]
#	set cpcont [ac_frame $topscroll.f ]
#	grid $cpcont 




	set topscroll [ac_frame $leftpane.f ]
	set cpcont $topscroll
	grid $cpcont -sticky we

	set toppane [$leftpane add $topscroll -weight 0]



	set bottomscroll [ VertScrollFrame create  $leftpane.scrollbot -side right]
	set botcont [VertScrollFrame get_container $bottomscroll]
	set bottompane [ $leftpane add $bottomscroll -weight 1]

	# set the sash position of the left pane from the prefs ONCE ONLY
	bind $UI(leftpane) <Expose> {
		global prefs_ui_leftpane_sash_percent UI
	
		set paneh [winfo height $UI(leftpane) ]
		$UI(leftpane) sashpos 0 [expr int((double($paneh)/100.0)*$prefs_ui_leftpane_sash_percent) ]
		bind $UI(leftpane) <Expose> ""
	}



	# $cp is the main control panel
    set cp $cpcont
	set UI(gadget_frame) $botcont

#	grid $cp -sticky ns

	set UI(bottombar) [ac_frame $UI(mainframe).bottombar ]
    pack $UI(bottombar) -side bottom -fill x

	# was -bd 3
    set UI(toolbar) [ ac_frame $UI(mainframe).toolbar -pad {0 0 0 0} ]
    pack $UI(toolbar) -side top -fill x 

	set UI(infobar) [ac_frame $UI(mainframe).infobar]
    pack $UI(infobar) -side top -fill x -expand 0

    set UI(viewcanvas) [ac_canvas $UI(mainframe).views -borderwidth 0 ]
    pack $UI(viewcanvas) -side left -fill both -expand 1 


########
# tried positioning the select mode box with the toolbar but looks rubbish - needs more thought
if { 0 } {
	set select_mode_frame [ac_frame $UI(toolbar).select_mode_frame -borderwidth 2 -relief raised]
	set f $select_mode_frame

    set UI(select_mode_tree) [add_tool_mode_button $f.select_mode_tree  " Group "  "ac3d set_select_mode  0; ac3d redraw_all" select_mode tree "Group - Select/manipulate\ngroups and objects" false group.png]
    set UI(select_mode_object) [add_tool_mode_button $f.select_mode_object  " Object "  "ac3d set_select_mode  1 ; ac3d redraw_all" select_mode object "Object - Select/manipulate\nwhole objects (key o)" false object.png]
    set UI(select_mode_surface) [add_tool_mode_button $f.select_mode_surface  " Surface "  "ac3d set_select_mode  2 ; ac3d redraw_all"  select_mode surface "Surface - Select/manipulate individual\nsurfaces (key s)" false surface.png]
    set UI(select_mode_vertex) [add_tool_mode_button $f.select_mode_vertex  " Vertex "  "ac3d set_select_mode  3 ; ac3d redraw_all"  select_mode vertex "Vertex - Select/manipulate individual\nvertices (key v)" false vertex.png]

	grid $UI(select_mode_tree) -row 0 -column 0 -sticky we
	grid $UI(select_mode_object) -row 0 -column 1 -sticky we
	grid $UI(select_mode_surface) -row 0 -column 2 -sticky we
	grid $UI(select_mode_vertex) -row 0 -column 3 -sticky we
	grid columnconfigure $f "all" -weight 1

pack $select_mode_frame -side left
}
######

	source "tcl/ac3dmenu.tcl"
	add_main_menu .mbar

	source tcl/toolbar.tcl
	populate_toolbar

	make_control_panel    
	
	build_gadgets $UI(gadget_frame)    


	populate_bottombar


	# in ac3dview.tcl:
	make_views 





##########################################################








proc get_cmd {sock} {
global prefs_allow_socket_commands
global errorInfo

    gets $sock cmd

    set result Error

    if { !$prefs_allow_socket_commands } {
        set result "Socket commands not authorized - settings->allow_socket_commands is not enabled"
    } else {
		if { $cmd == "exit" } {
			set cmd menu_quit
		}
        catch { set result [ uplevel #0 $cmd ] } errmsg
        if {$errmsg != 0} { set result $errmsg }
    }

    set len [string length $result]
    if { $len == 0 } {
       puts $sock "0"
    } else {
        # remember to add one to the length of the string
        puts $sock [expr $len+1]
    }

    set err [catch {flush $sock} ]
    if {$err == 1} 	{ 
        puts "Socket connection $sock gone"; close $sock ; return;
        }
    if { $len > 0 } {
        set err [catch {puts $sock $result}]
        set err [catch {flush $sock}]
        }

}


proc send_sock { str } {
global rsock

    set len [string length $str]
    puts $rsock $len
    flush $rsock
    if {$len > 0} {
        puts $rsock $str
        flush $rsock
        }
}



set listensock 0
set rsock 0

proc do_connection {sock ip port} {

	fileevent $sock readable "get_cmd $sock"
	puts "New socket connected to AC3D (socket id $sock, remote ip:port $ip:$port)"

	close_current_command_socket
	set_command_socket $sock
}


proc enable_socket_commands {} {

	global prefs_tcl_socket_port
	global listensock

	set sock 0

	set err [catch {set sock [socket -server do_connection $prefs_tcl_socket_port]} ]

	if { $err != 0 } {
		set sock 0
	}

	if { $sock != 0 } {
		puts "tcl socket id: $sock"
	}

	set listensock $sock
}


proc disable_socket_commands {} {

	global listensock

	if { $listensock != 0 } {

		close_current_command_socket

		set err [catch { close $listensock }]
		set listensock 0
	}

#	puts "Command socket connections disabled"
}


proc set_command_socket { sock } {

	global rsock

	set rsock $sock
}


proc close_current_command_socket {} {

	global rsock

	if { $rsock != 0 } {
		set err [catch { close $rsock }]
		puts "tcl socket $rsock disconnected by AC3D"
		set rsock 0
	}
}


proc set_socket_commands {} {

	global prefs_allow_socket_commands
	global prefs_tcl_socket_port
	global listensock

	if { $prefs_allow_socket_commands } {

		if { $listensock != 0 } {
			return
		} else {
			enable_socket_commands
		}

		if { $listensock != 0 } {
			puts "Command socket connections enabled on port $prefs_tcl_socket_port"
		} else {
			puts "Failed to enable AC3D tcl socket on port $prefs_tcl_socket_port"
		}

	} else {
		disable_socket_commands
	}
}

# init command socket settings
set_socket_commands



#fconfigure $sock -blocking true
#puts "tcl_socket_port $prefs_tcl_socket_port"























set move_x 0
set move_y 0
set move_z 0
set size_x 1
set size_y 1
set size_z 1
set shift_x 0.1
set shift_y 0
set shift_z 0

set rotate_angle 90
set rotate_angle2 90

set scale_x 100
set scale_y 100
set scale_z 100

set extrudex 0
set extrudey 0
set extrudez 1

#hack for Macs where UI doesn't update after a grid manage
# not needed with most recent Tcl/TK?

proc exposeUI {win} {
update idletasks
event generate $win <Expose>
	return;

    set kids [winfo children $win]
	foreach i $kids { 
		exposeUI $i
	}
}






proc draw_mode_changed { name1 name2 op } {
global draw_mode last_draw_mode drag_mode last_drag_mode
global object_detail_canvas UIPARAM UI ac_platform

#puts "ac3d.tcl:draw_mode_changed drawmode $draw_mode  dragmode $drag_mode"

#pack propagate $object_detail_frame  0

if {$name1 == "draw_mode" } {
    if {$draw_mode == $last_draw_mode } {return}




    # remove any widgets that are in there
    set todie [winfo children $UI(object_detail_frame)]

#    foreach die $todie { destroy $die }

	# unpack all/any widgets from the frame
foreach die $todie { pack forget $die }
#puts "todie $todie"

#puts "DRAWMODE $draw_mode"

	# test to see if we've already made the correct parmeter frame for this mode
	set res [catch { set causeanerrorifnotdefined "$UIPARAM($draw_mode)" } ]

	if { $res == 0 } {
		#puts "UI already built for $draw_mode"
		set pane $UIPARAM($draw_mode) 
		pack $pane -fill both

		set last_draw_mode $draw_mode
		set last_drag_mode $drag_mode

		# force Mac to update widgets (tk bug)
		if { $ac_platform == "Mac" } {
			exposeUI $pane
		}

		set_mode_param_title $draw_mode

		return

	} else {
		#puts "not defined - making for $draw_mode"
		set UIPARAM($draw_mode) [ac_frame $UI(object_detail_frame).$draw_mode ]
		set object_detail_frame $UIPARAM($draw_mode)
		pack  $UIPARAM($draw_mode) -fill both
		grid columnconfigure  $UIPARAM($draw_mode) 0 -weight 1 
		grid columnconfigure  $UIPARAM($draw_mode) 1 -weight 1 
		grid columnconfigure  $UIPARAM($draw_mode) 2 -weight 1 
		grid columnconfigure  $UIPARAM($draw_mode) 3 -weight 1
		grid columnconfigure  $UIPARAM($draw_mode) 4 -weight 1
	}

	set_mode_param_title $draw_mode

	set entry_width 5




	if { $draw_mode != "rotate" } {
		ac_create_pair_label_bool $object_detail_frame prefs_gridsnap "Gridsnap" "snap to grid when drawing and dragging"
	}

	if { ($draw_mode == "rotate") || ($draw_mode == "move") || ($draw_mode == "extrude") } {
		ac_create_pair_label_bool $object_detail_frame prefs_select_transparent "Select through" "Select all the way through geometry?"
	}




	if { ($draw_mode == "polygon") || ($draw_mode == "polyline") || ($draw_mode == "line")} {
        ac_create_pair_label_bool $object_detail_frame prefs_snap_near "Nearsnap" "snap to near points when drawing\npolys/polylines/lines"
		display_message "Click to add each vertex, right-mouse-button to finish"

    } elseif {$draw_mode == "sphere"} {
   #     ac_create_pair_label_title $object_detail_frame "Sphere parameters:"
        ac_create_pair_label_spinbox $object_detail_frame prefs_num_surface_div "Segments" "number segments of new sphere" 3 3 999 
        ac_create_pair_label_bool $object_detail_frame prefs_sphere_triangles "Triangles" "construct new spheres from triangles or quads?"
		display_message "Click (or press/drag) to add sphere.  Hold down Ctrl to drag regular shape."

    } elseif { $draw_mode == "mesh" } {
  #      ac_create_pair_label_title $object_detail_frame "Mesh parameters:"
        ac_create_pair_label_bool $object_detail_frame prefs_mesh_triangles "Triangles" "construct new meshes from triangles or quads?"
        ac_create_pair_label_spinbox  $object_detail_frame prefs_meshx "X sections" "X sections for squares in new 'Mesh' objects" 3 1 999
        ac_create_pair_label_spinbox $object_detail_frame  prefs_meshy "Y sections" "Y sections for squares in new 'Mesh' objects" 3 1 999 
		display_message "Click (or press/drag) to add mesh.  Hold down Ctrl to drag regular shape."

    } elseif { $draw_mode == "block" } {
 #       ac_create_pair_label_title $object_detail_frame "Block parameters:"
        ac_create_pair_label_spinbox  $object_detail_frame prefs_blockx "X sections" "X sections for squares in new 'Block' objects" 3 1 999
        ac_create_pair_label_spinbox $object_detail_frame  prefs_blocky "Y sections" "Y sections for squares in new 'Block' objects" 3 1 999
        ac_create_pair_label_spinbox $object_detail_frame  prefs_blockz "Z sections" "Z sections for squares in new 'Block' objects" 3 1 999
		display_message "Click (or press/drag) to add block.  Hold down Ctrl to drag regular shape."

    } elseif { $draw_mode == "grid" } {
  #      ac_create_pair_label_title $object_detail_frame "Grid parameters:"
        ac_create_pair_label_spinbox  $object_detail_frame prefs_grid_object_x "X sections" "X sections for squares in new grid" 3 1 999
        ac_create_pair_label_spinbox $object_detail_frame  prefs_grid_object_y "Y sections" "Y sections for squares in new grid" 3 1 999
		display_message "Click (or press/drag) to add grid.  Hold down Ctrl to drag regular shape."

    } elseif { $draw_mode == "circle"} {
#        ac_create_pair_label_title $object_detail_frame "Ellipse parameters:"
        ac_create_pair_label_spinbox $object_detail_frame prefs_ellipse_segments "Points" "number of points in circle" 3 3 255
		display_message "Click (or press/drag) to add ellipse.  Hold down Ctrl to drag regular shape."

    } elseif { $draw_mode == "disk"} {
#        ac_create_pair_label_title $object_detail_frame "Disk parameters:"
        ac_create_pair_label_spinbox $object_detail_frame prefs_disk_segments "Segments" "segments of disk" 4 3 999
		display_message "Click (or press/drag) to add disk.  Hold down Ctrl to drag regular shape."

    } elseif { $draw_mode == "cylinder"} {
#        ac_create_pair_label_title $object_detail_frame "Cylinder parameters:"
        ac_create_pair_label_spinbox $object_detail_frame prefs_cylinder_segments "Segments" "segments of cylinder" 3 3 999
		ac_create_pair_label_bool $object_detail_frame prefs_cylinder_has_ends "Cap ends" "add surfaces to the ends of the new cylinder?"
		display_message "Click (or press/drag) to add cylinder.  Hold down Ctrl to drag regular shape."

    } elseif { $draw_mode == "light"} {
		display_message "click to position a new light"

    } elseif { $draw_mode == "box"} {
		display_message "Click (or press/drag) to add box.  Hold down Ctrl to drag regular shape."

    } elseif {$draw_mode == "extrude"} {
 #       ac_create_pair_label_title $object_detail_frame "Extrude parameters:"

	#	ac_create_pair_separator $object_detail_frame 
    # now we have thicken, extrude can default to the most useful setting - extrude function ignores these now 
	#ac_create_pair_label_bool $object_detail_frame prefs_extrude_cap_end "Cap end" "Cap the end of the extrusion?"
		#ac_create_pair_label_bool $object_detail_frame prefs_extrude_flip_cap "Flip new surf" "Flip the direction of the new surfaces?"
		#ac_create_pair_label_bool $object_detail_frame prefs_extrude_delete_original "Remove orig" "Remove the original surfaces?"

		display_message "Drag the selection to extrude. Hold down Ctrl to fix drag direction."


    } elseif {$draw_mode == "rotate"} {
		
		ac_create_pair_label_bool $object_detail_frame prefs_rotate_about_object_centre "Use obj center" "Mouse rotates about object center ('Loc' in object properties)"

		ac_create_pair_separator $object_detail_frame 

		ac_frame $object_detail_frame.rf
		# rotate axis angle
		
		
		
		# rotate axis angle
		set rf [ ac_frame $object_detail_frame.raf ]
		set s2 [ac_axis_selector $rf.rot rotate_axis2]
		set s3 [ac_create_field_float $rf.angle rotate_angle2 "" 4 ]
		

		set rbf [ ac_frame $object_detail_frame.rbf ]
		set srl [ac_label $rbf.srl -text "Rotate"]
		set sb [cbutton $rbf.rb1 "+" { axis_selector_do_rotate rotate_axis2 $rotate_angle2 } "rotate the selection around the selected axis" ]
		set sbm [cbutton $rbf.rb2 "-"  { axis_selector_do_rotate rotate_axis2 -$rotate_angle2 } "rotate the selection around the selected axis" ]
		button_set_autorepeat $sb
		button_set_autorepeat $sbm

		grid config $rf -row 14 -column 0 -sticky w -padx 0 -columnspan 2
		grid config $s2 -row 0 -column 0 -sticky e -padx 2 -columnspan 2 -sticky w
		grid config $s3 -row 0 -column 2 -sticky e -padx 0
		grid config $rbf -row 15 -column 0 -padx 0 -columnspan 4 -sticky w

		grid config $srl -row 15 -column 0 -sticky we -pady 3 -columnspan 1
		grid config $sb -row 15 -column 1 -sticky we -pady 3 -columnspan 1
		grid config $sbm -row 15 -column 2 -sticky we -pady 3 -columnspan 1
		
		grid config $object_detail_frame.rf -row 15 -column 0 -sticky w 
		       	
		display_message "Hold down left mb over selection and drag left/right to rotate."


    } elseif {$draw_mode == "move"} {
 

		
		display_message "Select/move/resize with left mb.  Hold Ctrl for more control dragging/sizing."

    }



}

    set last_draw_mode $draw_mode
    set last_drag_mode $drag_mode
}













if { [file exists "tcl/patch.tcl"]} { 
    source "tcl/patch.tcl"
} 

set last_draw_mode nothing

recent_file_menu_check



wm deiconify .
raise .
focus .


# if a messagebox pops up, before the main window is made, saying "a newer license is needed",
# then there are problems opening windows and displaying popups (until a grabbed window pops up or the 
# main app icon so clicked on.  a grab 1/2 fixes this, in that popup help now works. but windows still do not show.
# grab .
# ^fixed NOV 2016 by reordering startup and adding some tk updates etc



recolor_old_widgets
catch { console hide }



# register toplevel window for drag/drop

	# register toplevel window for drag/drop
catch { 
tkdnd::drop_target register . *
	bind . <<Drop>> "files_dropped %D %W %X %Y"
	}

#  this is caled if a file gets dropped on the toplevel window
proc files_dropped { dropped win x y} {
#	puts "files dropped $dropped $win $x $y"

	lassign [winfo pointerxy .] x y
	set win [winfo containing $x $y]


	set mx [winfo pointerx $win]
	set my [winfo pointery $win]
	set rx [winfo rootx $win]
	set ry [winfo rooty $win]
	set wx [expr $mx-$rx]
	set wy [expr $my-$ry]

#	puts "OVER $win at $mx $my $rx $ry $wx $wy"

	foreach f $dropped {
		set isgeom [ac3d file_is_recognized_geometry "$f"]

		if { $isgeom } {
			ac3d load_file "$f"
		} else {
			set isimage [ac3d file_is_recognized_image "$f"]
			if { $isimage } {
#				puts "Image file dropped"
				set ob [ac3d get_object_under_mouse $win $wx $wy]
				if { $ob ne "0"  } {
					ac3d search_and_set_texture $ob "$f" "$f"
					ac3d redraw_all
				}

			} else {
				display_message "$f is not a recognised file format"
			}
		}
	}

}



#bind . <Configure> { 
#	set win %W
#	puts "CONFIGURE %W %x %y %w %h"
##	if { $win == "." } { display_message "%w %h"}
#}

